SystemOrganization addCategory: #VisibilityProfiler!

Profiler subclass: #VisibilityProfiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VisibilityProfiler'!

!VisibilityProfiler class methodsFor: 'hooks' stamp: 'SantiagoVidal 4/30/2012 17:06'!
spyClassForPackage
	 ^ VisibilityProfilerPackage! !

!VisibilityProfiler methodsFor: 'hooks' stamp: 'SantiagoVidal 4/30/2012 17:06'!
registryName
	^ #VisibilityProfiler! !

!VisibilityProfiler methodsFor: 'visualization' stamp: 'SantiagoVidal 4/30/2012 17:06'!
visualizeOn: view
	view nodes: self allClasses forEach: [ :each | 
		view nodes: each methods.
		view gridLayout gapSize: 2.
	].
	view edgesFrom: #superclass.
	view treeLayout
	! !

TestCase subclass: #ProfilerTests
	instanceVariableNames: 'profiler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VisibilityProfiler'!

!ProfilerTests methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 4/30/2012 18:31'!
initialize
	profiler:=VisibilityProfiler profile: [TGDriver new isFemale] inClassCategory: 'Spy-ScenarioExample'.! !

!ProfilerTests methodsFor: 'methodKindTests' stamp: 'SantiagoVidal 4/30/2012 19:27'!
testPrivateMethod
	|methods|
	methods:=profiler allMethods.
	self halt..
	methods do:[:am| (am callerMethods size >0) ifTrue:[Transcript show:am name asString;cr. self halt]].
	methods do:[:am| (am isPrivate ) ifTrue: [ (am callerMethods size >0) ifTrue:[Transcript show:am name asString;cr. self halt]. ]]! !

MethodSpy subclass: #VisibilityProfilerMethod
	instanceVariableNames: 'callerMethods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VisibilityProfiler'!

!VisibilityProfilerMethod methodsFor: 'hooks' stamp: 'SantiagoVidal 4/30/2012 17:51'!
beforeRun: methodName with: listOfArguments in: receiver
	callerMethods add:(self callingMethod).
	! !

!VisibilityProfilerMethod methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 4/30/2012 19:47'!
callerMethods
	^callerMethods.! !

!VisibilityProfilerMethod methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 4/30/2012 17:56'!
initialize
	super initialize.
	callerMethods:=IdentitySet new.! !

!VisibilityProfilerMethod methodsFor: 'kindOfMethod' stamp: 'SantiagoVidal 4/30/2012 18:54'!
isPrivate

	^ callerMethods inject: true into: [ :result :m |  result and: [ m methodClass == self theClass ]]
	
"	(callerMethods size>0 ) ifTrue:[
		callerMethods do:[:aCallerMethod| 
			|class1 class2|
			class1:=self className.
			class2:=aCallerMethod methodClass name.
			self halt.
			(self className = aCallerMethod methodClass name) ifTrue:[Transcript show: 'Al menos uno'] ifFalse:[^false]. ]. ^true
	] ifFalse:[^false].
	"! !

!VisibilityProfilerMethod methodsFor: 'kindOfMethod' stamp: 'SantiagoVidal 4/30/2012 19:07'!
isProtected
	self isPrivate ifTrue: [^false].
	^ callerMethods inject: true into: [ :result :m |  (result and: [ m methodClass == self theClass ]) or: [ self theClass subclasses includes: (m methodClass) ]]! !

!VisibilityProfilerMethod methodsFor: 'kindOfMethod' stamp: 'SantiagoVidal 4/30/2012 19:10'!
isPublic
	self isUncalled ifTrue: [^false].
	self isPrivate ifTrue: [^false].
	self isProtected ifTrue: [^false].
	^true.! !

!VisibilityProfilerMethod methodsFor: 'kindOfMethod' stamp: 'SantiagoVidal 4/30/2012 18:02'!
isUncalled
	^callerMethods size==0.! !

AbstractSpyTest subclass: #VisibilityProfilerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VisibilityProfiler'!

!VisibilityProfilerTest methodsFor: 'hooks' stamp: 'SantiagoVidal 4/30/2012 17:06'!
profilerClass
	^  VisibilityProfiler! !

!VisibilityProfilerTest methodsFor: 'tests' stamp: 'SantiagoVidal 4/30/2012 19:44'!
testPrivateMethod
	|methods|
	methods:=self runScenario allMethods.
	self halt.
	methods do:[:am| ((am callerMethods) size >0) ifTrue:[Transcript show:am name asString;cr. "self halt"]].
	methods do:[:am| (am isPrivate ) ifTrue: [ (am callerMethods size >0) ifTrue:[Transcript show:am name asString;cr. "self halt"]. ]]! !

PackageSpy subclass: #VisibilityProfilerPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VisibilityProfiler'!

!VisibilityProfilerPackage class methodsFor: 'hooks' stamp: 'SantiagoVidal 4/30/2012 17:06'!
spyClassForClass
	 ^ VisibilityProfilerClass! !

ClassSpy subclass: #VisibilityProfilerClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VisibilityProfiler'!

!VisibilityProfilerClass class methodsFor: 'hooks' stamp: 'SantiagoVidal 4/30/2012 17:06'!
spyClassForMethod
	 ^ VisibilityProfilerMethod! !
